# generated by datamodel-codegen:
#   filename:  wsfe.yaml

from __future__ import annotations

from datetime import datetime
from enum import Enum
from typing import List, Optional

from pydantic import Field

from cognite.well_model.base_model import WellsBaseModel


class ProcessIdItems(WellsBaseModel):
    class Config:
        allow_population_by_field_name = True

    items: List[str]


class FileType(Enum):
    las = "las"
    dlis = "dlis"
    asc = "asc"


class ProcessStatus(Enum):
    ready = "ready"
    processing = "processing"
    done = "done"
    error = "error"


class Severity(Enum):
    info = "info"
    warning = "warning"
    error = "error"


class JobSource(WellsBaseModel):
    class Config:
        allow_population_by_field_name = True

    file_external_id: str = Field(..., alias="fileExternalId")
    file_type: FileType = Field(..., alias="fileType")


class JobDestination(WellsBaseModel):
    class Config:
        allow_population_by_field_name = True

    data_set_external_id: str = Field(..., alias="dataSetExternalId")
    sequence_external_id_prefix: Optional[str] = Field(None, alias="sequenceExternalIdPrefix")


class SubmitJob(WellsBaseModel):
    class Config:
        allow_population_by_field_name = True

    source: JobSource
    destination: JobDestination


class ProcessingLog(WellsBaseModel):
    class Config:
        allow_population_by_field_name = True

    timestamp: datetime
    severity: Severity
    message: str


class SubmitRequest(WellsBaseModel):
    class Config:
        allow_population_by_field_name = True

    overwrite: Optional[bool] = False
    overwrite_sequences: Optional[bool] = Field(
        False,
        alias="overwriteSequences",
        description="Deprecated, use overwrite instead. If both overwriteSequences and overwrite are specified overwrite is used.",
    )
    enable_time_series: Optional[bool] = Field(
        False,
        alias="enableTimeSeries",
        description="Enables creation of time series from time indexed files. Experimental - defaults to false",
    )
    items: List[SubmitJob]


class ProcessState(WellsBaseModel):
    class Config:
        allow_population_by_field_name = True

    process_id: str = Field(..., alias="processId")
    status: ProcessStatus
    file_external_id: str = Field(..., alias="fileExternalId")
    created_sequences: List[str] = Field(..., alias="createdSequences")
    created_timeseries: List[str] = Field(..., alias="createdTimeseries")
    logs: List[ProcessingLog]


class ProcessStateItems(WellsBaseModel):
    class Config:
        allow_population_by_field_name = True

    items: Optional[List[ProcessState]] = None
